#ifndef SW_CONSTANTS_H
#define SW_CONSTANTS_H


#include <math.h>


// Run variables.
const size_t runCount = 10;
const size_t generationCount = 1000;

// Population and selection variables.
const size_t tournamentSize = 4; // >= 4
const size_t tournamentCount = 15;
const size_t populationSize = tournamentSize * tournamentCount;

// GP Automata
const size_t stateCount = 12;

// Integer Parse Trees
const size_t maxDeciderSize = 12;
const size_t initialDeciderSize = 8;

const float PI = atan(1.0f) * 4;
const float PI_2 = PI * 2.0f;

// Submarine
const size_t weaponCount = 3;
const size_t totalWeapons = 20;
const float maxDamage = 4.0f;
const float forwardTorpedoDamage = 0.50f;
const float aftTorpedoDamage = 0.50f;
const float pulseRange = 20.0f;
const float pulseDamage = 5.0f;

// Battle
const float maxStartingRadius = 50.0f;
const float battleDT = 0.1f;
const float battleTimeLimit = 200.0f;


enum Input {
    ForwardCount,
    AftCount,
    PulseCount,
    Distance,
    Angle,

    inputCount,
};

enum Action {
    Think,
    FireForward,
    FireAft,
    FirePulse,
    TurnLeft,
    TurnRight,
    SpeedUp,
    SlowDown,

    actionCount,
};


#endif
