#ifndef SW_STATISTICS_H
#define SW_STATISTICS_H


class Statistics {
public:
    Statistics() {
        const float INF = 1000000;

        _total = 0;
        _count = 0;
        _min = +INF;
        _max = -INF;
    }

    void add(float value) {
        _total += value;
        ++_count;
        if (value < _min) {
            _min = value;
        }
        if (value > _max) {
            _max = value;
        }
    }
    
    size_t getCount() const {
        return _count;
    }

    float getAverage() const {
        return _total / _count;
    }

    float getMin() const {
        return _min;
    }
    
    float getMax() const {
        return _max;
    }

private:
    float _total;
    size_t _count;
    float _min;
    float _max;
};


#endif
