//go get some standard libraries
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cctype>
#include "its.h"
#include "Random378.h"
using namespace std;

//Uses dollar signs in printing predicate
int dollarP=0;

//Some utility variables
int numv=1;               //number of variables - Start univariate

//constant range -CSize+1 to CSize-1   or 0 to Csize-1
int CSize=3;

//initialize to permitting signed constants
int Signed=1;

//operation names
#define NU 3
char *nameU[NU]={"~","Odd","Com"}; //names of unary operations
#define NB 10
char *nameB[NB]={"+","-","=",">=","<=","<>","<",">","max","min"};
#define NT 1
char *nameT[NT]={"ITE"};   //names of trinary operations


//Routine to generate random constants
int RandConst(){

int q;

  q=lrandMT()%CSize;
  if(Signed && (lrandMT()%2==0))q +=1280; else q+=1024;
  return(q);

}

int RandL(){//generate the opcode of a random leaf


  if(lrandMT()%2==0)
    return(lrandMT()%(numv));
  else
    return(RandConst());
}

int RandU(){//generate the opcode of a random unary operation

  return(lrandMT()%NU)+256;  //~ odd com

}

int RandB(){//generate the opcode of a random binary operation

  return(lrandMT()%NB)+512; //+,-,=,>=,<=,<>,>,<,max,min

}

int RandT(){//generate the opcode of a random trinary operation

  return(lrandMT()%NT+768);  //ITE

}

//Routine used to set dollarp...
void DollarLess(int p){

   dollarP=p;  //if dollarP then $>$ $<$ otherwise > and <

}

//Routine to set the number of variables
void SetNumv(int n){

   numv=n;

}

//Routine to set the signed constant flag
void SignedCon(int n){

   Signed=n;

}

//Routine to set the maximum magnitude of real constants
void SetConstSize(int n){

   CSize=n;

}

/***************I/O*********************************/

void Print(ostream &aus,int *n,int &p){

   switch (n[p]/256) {
      case 0: if(dollarP)aus << "$x_{" << (n[p]+1)<<"}$";
              else aus<<"x"<<(n[p]+1);
  	      p++;
	      break;
      case 4: aus << n[p]%256;
	      p++;
	      break;
      case 5: aus << -(n[p]%256);
  	      p++;
	      break;
      case 1: aus<<"(";
	      if((dollarP)&&(n[p]==256))aus << "$\\sim$ ";
              else aus<<nameU[n[p]% 256]<<" ";
              p++;
              Print(aus,n,p);
              aus<<")";
              break;
      case 2: aus<<"(";
              if((dollarP)&&(515<=n[p])&&(519>=n[p]))aus << "$";
	      aus<<nameB[n[p]% 256];
              if((dollarP)&&(515<=n[p])&&(519>=n[p]))aus << "$";
              aus << " ";
              p++;
              Print(aus,n,p);
	      aus << " ";
              Print(aus,n,p);
              aus << ")";
              break;
      case 3: aus<<"(";
	      aus<<nameT[n[p]%256] << " ";
              p++;
              Print(aus,n,p);
              aus << " ";
              Print(aus,n,p);
	      aus << " ";
              Print(aus,n,p);
              aus << ")";
              break;
   }
}

void Print(ostream &aus,int *n){

int p=0;

  Print(aus,n,p);
 
}

/**********Tree creation and deletion**************/
extern void RandTree(int *t,int n){//generate a random tree

int a,b,c,d;


  if(n==1){
    t[0]=RandL();  //a one node tree is a random leaf
  } else if(n==2){
    t[0]=RandU();  //a two none tree is (unary leaf)
    t[1]=RandL();
  } else if(n==3){ //a three node tree is (binary leaf leaf)
    t[0]=RandB();
    t[1]=RandL();
    t[2]=RandL();
  } else {
    switch(lrandMT()%9){
    case 0: //unary
    case 1:
      t[0]=RandU();
      RandTree(t+1,n-1);  //recursion
      break;
    case 2: //binary
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
      t[0]=RandB();
      a=lrandMT()%(n-2)+1;  //divide the
      b=n-1-a;              //leftover nodes
      RandTree(t+1,a);      //recurse left
      RandTree(t+1+a,b);    //recurse right
      break;
    case 8: //trinary
      d=n-4;
      a=b=c=1;
      while(d){//deal out remaining nodes
        switch(lrandMT()%3){
        case 0: a++;
	  break;
        case 1: b++;
	  break;
        case 2: c++;
	  break;
	}
	d--;
      }
      t[0]=RandT();
      RandTree(t+1,a);       //recurse left
      RandTree(t+1+a,b);     //recurse center
      RandTree(t+1+a+b,c);   //recurse right
      break;
    }
  }
}

void CopyTree(int *t,int *n){//copy a tree  t <= n

int q=SizeTree(n);
  
  for(int i=0;i<q;i++)t[i]=n[i]; 

}

/**********Evaluation and counting routines********/
int SizeTree(const int *t){//compute the size of a tree

int c,l,p;
  
  p=c=l=0;
  while(c>=0){
    l++;
    switch(t[p]/256){
    case 0:
    case 4:
    case 5:
      c--;
      break;
    case 1:
      break;
    case 2:
      c++;
      break;
    case 3:
      c+=2;
      break;
    }
    p++;
  }

  return(l);

}

extern int EvalTreeV(const int *t,const int *v,int n){//evaluate a multivariate tree
                                          //the second argument must be
                                          //an array with enough entries
                                          //tree has n nodes

int vs[1000];
int ptr=0;
int i;

  for(i=n-1;i>=0;i--){
    if(t[i]<256){
      vs[ptr++]=v[t[i]]; //load variable
    } else if(t[i]>1023){//load constant
      vs[ptr++]=t[i]%256;
      if(t[i]>1279)vs[ptr-1]=-vs[ptr-1]; //check for negative
    } else switch(t[i]){
      /**********************Unary***********************/
    case 256: //negation
      vs[ptr-1]=-vs[ptr-1];
      break;
    case 257 : //Odd predicate
      if(vs[ptr-1]%2)vs[ptr-1]=1; else vs[ptr-1]=0;
      break;
    case 258 : //complement
      vs[ptr-1]=1-vs[ptr-1];
      break;
      /**********************Binary***********************/
    case 512: //addition
      vs[ptr-2]=vs[ptr-2]+vs[ptr-1];
      ptr--;
      break;
    case 513: //subtraction
      vs[ptr-2]=vs[ptr-1]-vs[ptr-2];
      ptr--;
      break;
    case 514 : //Equality predicate
      if(vs[ptr-1]==vs[ptr-2])vs[ptr-2]=1; else vs[ptr-2]=0;
      ptr--;
      break;
    case 515 : //>= predicate
      if(vs[ptr-1]>=vs[ptr-2])vs[ptr-2]=1; else vs[ptr-2]=0;
      ptr--;
      break;
    case 516 : //<= predicate
      if(vs[ptr-1]<=vs[ptr-2])vs[ptr-2]=1; else vs[ptr-2]=0;
      ptr--;
      break;
    case 517 : //<>
      if(vs[ptr-1]!=vs[ptr-2])vs[ptr-2]=1; else vs[ptr-2]=0;
      ptr--;
      break;
    case 518 : //< predicate
      if(vs[ptr-1]<vs[ptr-2])vs[ptr-2]=1; else vs[ptr-2]=0;
      ptr--;
      break;
    case 519 : //>
      if(vs[ptr-1]>vs[ptr-2])vs[ptr-2]=1; else vs[ptr-2]=0;
      ptr--;
      break;
    case 520 : //Maximum
      if(vs[ptr-1]>vs[ptr-2])vs[ptr-2]=vs[ptr-1];
      ptr--;
      break;
    case 521 : //Minimum
      if(vs[ptr-1]<vs[ptr-2])vs[ptr-2]=vs[ptr-1];
      ptr--;
      break;
      /**********************Trinary**********************/
    case 768: //if-then-else
      if(vs[ptr-3])vs[ptr-3]=vs[ptr-2]; else vs[ptr-3]=vs[ptr-1];
      ptr-=2;
      break;
               
    }
  }
  ptr--;
  return(vs[ptr]);

}

extern int EvalTreeV(const int *t,const int *v){//evaluate a multivariate tree t on v
                                   //the second argument must be
                                  //an array with enough entries
  int n=SizeTree(t);
  return(EvalTreeV(t,v,n));

}

/****************Genetic Routines******************/
//Return a random node in the range 0..k-1.  It is he users job to pass
//a reasonable value.  This routine exists mostly as a helper to

//Cross over a pair of trees at a random point
extern void Cross(int *n,  //First tree
                  int *m,  //Second tree
		  int mts  //maximum tree size
		  ){

int ln,lm;            //lengths of trees being crossed over
int cn,cm;            //crossover points for n and m
int a[1000],b[1000];  //crossover buffers
int i,j;              //loop indices
int r,s;              //lengths of crossed over bits

  ln=SizeTree(n);
  lm=SizeTree(m);
  cn=lrandMT()%ln;
  cm=lrandMT()%lm;
  r=SizeTree(m+cm);                //compute size of crossed over bits
  s=SizeTree(n+cn);

  for(i=0;i<cn;i++)a[i]=n[i];                //copy to crossover points
  for(i=0;i<r;i++)a[cn+i]=m[cm+i];           //copy crossed subtree
  for(i=0;i<ln-s-cn;i++)a[cn+r+i]=n[cn+s+i]; //copy remainder

  for(i=0;i<cm;i++)b[i]=m[i];                //copy to crossover points
  for(i=0;i<s;i++)b[cm+i]=n[cn+i];           //copy crossed subtree
  for(i=0;i<lm-r-cm;i++)b[cm+s+i]=m[cm+r+i]; //copy remainder

  //perform size control
  r=SizeTree(a);
  if(r>mts){//if too big
    do {
      j=lrandMT()%r;   //find a non-leaf subtree
      s=SizeTree(a+j);
    } while((s>mts)||(s==1));
    for(i=0;i<s;i++)n[i]=a[i+j];  //and replace the main tree with it
  } else for(i=0;i<r;i++)n[i]=a[i]; //else just copy
  
  r=SizeTree(b);
  if(r>mts){//if too big
    do {
      j=lrandMT()%r; //find a non-leaf subtree
      s=SizeTree(b+j);
    } while((s>mts)||(s==1));
    for(i=0;i<s;i++)m[i]=b[i+j];  //and replace the main tree with it
  } else for(i=0;i<r;i++)m[i]=b[i];  //else just copy
 
}

//Mutate a tree, replacing a subtree with a random subtree the same size
extern void Mutate(int *n){

int i,z;

  i=lrandMT()%SizeTree(n);
  z=SizeTree(n+i);
  RandTree(n+i,z);  

}

extern void str2tree(int *t,char *s){//convert a string to a tree

int ptr=0;
int ip=0;
int d=0;
int i;
char q[20];

  do {
    if(s[ptr]=='('){
      d++;  //increament paren depth
      ptr++;
      //compile operation name
      i=0;
      while(s[ptr]!=' ')q[i++]=s[ptr++];
      q[i]='\0';
      ptr++;
      //identify operation name
      t[ip]=-1;
      for(i=0;(i<NU)&&(t[ip]<0);i++)if(strcmp(q,nameU[i])==0)t[ip]=256+i;
      for(i=0;(i<NB)&&(t[ip]<0);i++)if(strcmp(q,nameB[i])==0)t[ip]=512+i;
      for(i=0;(i<NT)&&(t[ip]<0);i++)if(strcmp(q,nameT[i])==0)t[ip]=768+i;
      //whine if not found
      if(t[ip]<0)cout << "??????" << q << endl;
      //record pointer
      ip++;
    } else {
      if(s[ptr]=='x'){//found a variable
        ptr++;
        t[ip]=atoi(s+ptr);
        t[ip++]--;
        while(isdigit(s[ptr]))ptr++;
        while(s[ptr]==' ')ptr++;
      } else if(s[ptr]=='-'){//found a negative ephemeral constant
        ptr++;
        t[ip]=atoi(s+ptr);
        t[ip++]+=1280;
        while(isdigit(s[ptr]))ptr++;
        while(s[ptr]==' ')ptr++;
      } else if(isdigit(s[ptr])){//found a positive ephemeral constant
        t[ip]=atoi(s+ptr);
	t[ip++]+=1024;
        while(isdigit(s[ptr]))ptr++;
        while(s[ptr]==' ')ptr++;
      } else if(s[ptr]==')'){
        ptr++;
        while(s[ptr]==' ')ptr++;
        d--;
      }
    }
  } while(d);
}
