#!/bin/sh

GENS=1000
XSCALE=1
TIME=200

cat <<EOF | gnuplot
set size $XSCALE,1
set terminal png color
set output "run$1.time.png"
plot [0:$GENS][0:$TIME] "$2" using 0:1 smooth bezier title "Time"        with lines,\
                        "$2" using 0:2 smooth bezier title "AvgDistance" with lines,\
                        "$2" using 0:3 smooth bezier title "MinDistance" with lines,\
                        "$2" using 0:4 smooth bezier title "MaxDistance" with lines
EOF

cat <<EOF | gnuplot
set size $XSCALE,1
set terminal png color
set output "run$1.weapon.png"
plot [0:$GENS][0:1] "$3" using 0:1 smooth bezier title "Forward" with lines,\
                    "$3" using 0:2 smooth bezier title "Aft"     with lines,\
                    "$3" using 0:3 smooth bezier title "Pulse"   with lines
EOF

cat <<EOF | gnuplot
set size $XSCALE,1
set terminal png color
set output "run$1.action.png"
plot [0:$GENS][0:1] "$4" using 0:1 smooth bezier title "Think"        with lines,\
                    "$4" using 0:2 smooth bezier title "FireForward"  with lines,\
                    "$4" using 0:3 smooth bezier title "FireAft"      with lines,\
                    "$4" using 0:4 smooth bezier title "FirePulse"    with lines,\
                    "$4" using 0:5 smooth bezier title "TurnLeft"     with lines,\
                    "$4" using 0:6 smooth bezier title "TurnRight"    with lines,\
                    "$4" using 0:7 smooth bezier title "SpeedUp"      with lines,\
                    "$4" using 0:8 smooth bezier title "SlowDown"     with lines

EOF

cat <<EOF | gnuplot
set size $XSCALE,1
set terminal png color
set output "run$1.hit.png"
plot [0:$GENS][0:1] "$5" using 0:1 smooth bezier title "Forward" with lines,\
                    "$5" using 0:2 smooth bezier title "Aft"     with lines,\
                    "$5" using 0:3 smooth bezier title "Pulse"   with lines
EOF

convert "run$1.action.png" "run$1.weapon.png" +append "run$1.top.png"
convert "run$1.time.png"   "run$1.hit.png"    +append "run$1.bottom.png"
convert "run$1.top.png" "run$1.bottom.png" -append "run$1.png"

rm "run$1.top.png"
rm "run$1.bottom.png"
rm "run$1.time.png"
rm "run$1.weapon.png"
rm "run$1.action.png"
rm "run$1.hit.png"
